import processing.sound.*;
import ddf.minim.*;

AudioPlayer player;
Minim minim;
AudioPlayer playercatchgold;
AudioPlayer playercatchstone;
AudioPlayer playercatchbomb;
Minim minimcatch;

PImage bg;
PImage bg2;
PImage bg3;

AudioIn input;
Amplitude volumeAnalyzer;
float micVolumeTarget;

boolean intro=true; //welcome page
boolean normal = false; //game page
boolean stop = false;
boolean isboom = false;

int score=0;
int bestscore = 0;
int P_size;

gold[] g = new gold[7];
stone[] s = new stone[7];
diamond d1;
bomb[] b = new bomb[3];
myShape p[] = new myShape[20];
cochet c;
myShape mys;
int y;
float deg = 0;
float deg2 = 0;
float rad;
float rad2;
int cochetLong;
int cochetShort;
boolean comeback  = false;
float angle1 = 0;
float weight = 100;
boolean a = true;

//time
int currentMillis;
int lastMillis = 0;

int startTime;



int totalSeconds = 60;
int currentSeconds;
boolean on = true;

void setup() {
  size(700, 700);
  input = new AudioIn(this, 0);
  input.start();


  volumeAnalyzer = new Amplitude(this);
  volumeAnalyzer.input(input);

  //time
  currentSeconds = totalSeconds;
  frame.setAlwaysOnTop(true);



  int i;

  for (i = 0; i<7; i++) {
    g[i]= new gold();
    s[i]= new stone();
    if (i<3)
      b[i]=new bomb();
  }
  for (i = 0; i<20; i++) {
    p[i] = new myShape();
  }


  d1 = new diamond();
  c = new cochet();
  mys = new myShape();
  bg = loadImage("bg.jpeg");
  bg2 = loadImage("bg2.jpeg");
  bg3 = loadImage("bg3.jpeg");


  minim = new Minim(this);
  player = minim.loadFile("backmusic.mp3", 1000);



  playercatchgold = minim.loadFile("catch.mp3", 1000);

  playercatchstone = minim.loadFile("stone.mp3", 1000);

  playercatchbomb = minim.loadFile("bomb.mp3", 1000);
}

void draw() {

  if (intro) {
    background(bg);
    rect(240, 200, 180, 50);
    fill(#FFFFFF);

    textSize(18);
    text("CLICK TO START", 255, 230);
    fill(#D6385D);

    rect(240, 130, 180, 50);
    fill(#FFFFFF);

    textSize(18);
    text("CATCH THE GIFT", 255, 160);
    fill(#D6385D);
  }

  if (normal) {

    background(bg2);
    jump();

    //time
    if (on) {
      currentMillis += millis() - lastMillis -startTime;
      lastMillis = millis()-startTime;

      if (currentMillis >= 1000) {
        currentMillis -= 1000;
        currentSeconds--;
        if (currentSeconds == 0) {
          on = false;
          stop = true;
          normal = false;
        }
      }
      textSize(30);
      int convertedHours, convertedMinutes, convertedSeconds;

      convertedSeconds = currentSeconds % 60;
      convertedMinutes = floor(currentSeconds / 60) % 60;
      convertedHours = floor(floor(currentSeconds / 60) / 60) % 60;

      text(toTwoDig(convertedHours) + ":" + toTwoDig(convertedMinutes) + ":" + toTwoDig(convertedSeconds), 30, 90);


      //score 
      fill(#D6385D);  
      rect(500, 60, 180, 50);
      fill(#FFFFFF);
      textSize(18);
      text("Score :"+score, 520, 90);
    } 

    g[0].display();
    //g[0].equal(p[0]);
    p[0] = g[0];
    int size = 0;
    size++;

    for (int i = 1; i<7; i++) {
      g[i].equal(mys);   
      if (testDistance(mys, p, size)) {
        g[i].display();
        size = size+1;
        p[size-1] = g[i];
      }
    }

    for (int i = 0; i<7; i++) {
      s[i].equal(mys);
      if (testDistance(mys, p, size)) {
        s[i].display();
        size = size+1;
        //s[i].equal(p[j-1]);
        p[size-1] = s[i];
      }
    }

    for (int i = 0; i< 3; i++) {
      b[i].equal(mys); 
      if (testDistance(mys, p, size)) {
        b[i].display();
        size = size+1;
        //b[i].equal(p[j-1]);
        p[size-1] = b[i];
      }
    }
    d1.display();
    c.display();
    P_size = size;
  }




  // page of stop
  if (stop) {
    if (score >= bestscore) {
      bestscore = score;
    }

    background(bg3);
    textSize(24);
    String text;
    if (isboom) {
      text = "Boom!!! YOUR SCORE IS : ";
    } else {
      text = "TIME UP! YOUR SCORE IS : ";
    }
    text(text+ score, 180, 120);

    fill(#FF4E08);
    text("YOUR BEST SCORE IS: " + bestscore, 210, 350);

    fill(#254883);  
    rect(240, 200, 230, 50);
    fill(#FFFFFF);
    textSize(14);
    text("CLICK TO START AGAIN!", 255, 230);
  }
}




String toTwoDig(int num) {
  if (num < 10) {
    return "0" + num;
  } else {
    return Integer.toString(num);
  }
}

void diamond(float x, float y, float size) {
  beginShape();
  vertex(x+size, y );
  vertex(x+size/2, y-size/2);
  vertex(x-size/2, y-size/2);
  vertex(x-size, y);
  vertex(x, y+size);
  endShape(CLOSE);
  stroke(0);
  line(x+size, y, x-size, y);
  line(x+size/2, y-size/2, x, y+size);
  line(x-size/2, y-size/2, x, y+size);
  noStroke();
}

void star(float x, float y, float size) {
  beginShape();
  vertex(x-size, y+size/3);
  vertex(x-size/5, y+size/3);
  vertex(x, y+size);
  vertex(x+size/5, y+size/3);
  vertex(x+size, y+size/3);
  vertex(x+size/2.8, y);
  vertex(x+size/1.5, y-size);
  vertex(x, y-size/3);
  vertex(x-size/1.5, y-size);
  vertex(x-size/2.8, y);
  endShape();
}


boolean testDistance(myShape s, myShape[] shapes, int size) {
  for (int i = 0; i<size; i++) {
    float dis = dist(s.x_, s.y_, shapes[i].x_, shapes[i].y_);
    if (dis <  s.size_ + shapes[i].size_) {
      return false;
    }
  }

  return true;
}

boolean test_touch(myShape p, float cochetlong) {
  float x_ = width/2 + cochetlong *cos(rad);
  float  y_ = height/2 - cochetlong *sin(rad);
  float dis = dist(x_, y_, p.x_, p.y_);
  if ((dis < p.size_-1) && (p.size_!=0)) {
    return true;
  } else {
    return false;
  }
}

boolean test_touch_dia(diamond d, float cochetlong) {
  float x_ = width/2 + cochetlong *cos(rad);
  float  y_ = height/2 - cochetlong *sin(rad);
  float dx = width/2 + d.l_ *cos(rad2);
  float  dy = height/2 + d.l_ *sin(rad2);
  float dis = dist(x_, y_, dx, dy);
  println("diadis : "+dis);
  if ((dis < 20)&&(d.size_!=0)) {
    return true;
  } else {
    return false;
  }
}


class cochet {
  cochet() {
  }

  void display() {
    pushMatrix();
    fill(255);
    translate(width/2, height/2);
    rotate(-rad);
    rect(0, 0, 40+cochetLong - cochetShort, 5);
    popMatrix();

    if (comeback) {
      cochetShort += 1;
      if (cochetShort == cochetLong) {
        comeback = false;
        cochetShort = cochetLong = 0;
        a = !a;
      }
    }
    if (a) {
      if (deg == 360.0) {
        deg = 0;
      }
      deg = deg+1.0;
      rad = radians(deg);
      cochetLong = 0;
    } else if (!comeback) {
      cochetLong += 1 ;
      boolean diamond_touch = test_touch_dia(d1, 40+cochetLong - cochetShort);  
      if (diamond_touch) {
        d1.delete();
        score = score + d1.score;
        comeback = true;
        playercatchgold.rewind();
        playercatchgold.play();
      }
      for (int i = 0; i<P_size; i++) {
        boolean shape_touch = test_touch(p[i], 40+cochetLong - cochetShort);
        if (shape_touch )
        {
          p[i].delete();
          score = score + p[i].score;
          comeback = true;
          if (score < 0) {
            playercatchstone.rewind();
            playercatchstone.play();
          }
          if (score > 0) {
            playercatchgold.rewind();
            playercatchgold.play();
          }
        }
        if ((40+cochetLong - cochetShort) >= width/2 ) {
          comeback = true;
        }
      }
    }
  }
}

class myShape {
  float x_, y_;
  float size_, a_;
  int score;


  myShape() {
    x_ = y_ = size_ = a_ = 0.0;
  }
  void equal(myShape p) {
    p.x_ = x_;
    p.y_ = y_;
    p.size_ = size_;
    p.a_ = a_;
    p.score = score;
  }
  void delete() {
    if (this instanceof bomb) {
      playercatchbomb.rewind();
      playercatchbomb.play();
      isboom = true;
      stop = true;
    }
    x_ = y_ = size_ = a_ = 0.0;
  }
}





class gold extends myShape {
  gold() {
    float r = random(50, 350);
    float d;
    if (50 <= r && r<= 100) {
      d = random(50, 100);
      size_ = 10;
      score = 20;
    } else if (100 < r && r<= 200) {
      d = random(100, 200);
      size_ = 20;
      score = 40;
    } else {
      d = random(200, 300);
      size_ = 30;
      score = 60;
    }
    a_ = random(0, 360);
    x_ = width/2 + d*cos(a_);
    y_ = height/2 + d*sin(a_);
  }

  void display() {    
    color inside;
    inside = #EBFC08;

    fill(inside);
    star(x_, y_, size_);
    noStroke();
  }

  void equal(myShape p) {
    p.x_ = x_;
    p.y_ = y_;
    p.size_ = size_;
    p.a_ = a_;
    p.score = score;
  }
}

class stone extends myShape {

  stone() {
    float r = random(50, 350);
    float d;
    if (50 <= r && r<= 100) {
      d = random(50, 100);
      size_ = 15;
      score = -10;
    } else if (100 < r && r<= 200) {
      d = random(100, 200);
      size_ = 25;
      score = -20;
    } else {
      d = random(200, 300);
      size_ = 35;
      score = -30;
    }
    a_ = random(0, 360);
    x_ = width/2 + d*cos(a_);
    y_ = height/2 + d*sin(a_);
  }
  void display() {    
    color inside;
    inside = #888986;
    fill(inside);
    rect(x_, y_, size_, size_);
    noStroke();
  }
  void equal(myShape p) {
    p.x_ = x_;
    p.y_ = y_;
    p.size_ = size_;
    p.a_ = a_;
    p.score = score;
  }
}

class diamond {
  float x_, y_;
  float l_;
  float size_;
  int score;
  boolean appear;

  diamond() {
    appear = true;
    x_ = random(90, 180);
    l_ = x_;
    y_ = 0;
    l_  = sqrt((x_*x_)+(y_*y_));
    score = 500;
    size_ =13;
  }
  void display() {    
    color inside;
    inside = #07AEE8;

    pushMatrix();
    translate(width/2, height/2);
    rotate(rad2);
    fill(inside);
    diamond(x_, y_, size_ );
    popMatrix();
    if (deg2 ==360) {
      deg2 = 0;
    }
    deg2 = deg2+0.5;
    rad2 = radians(deg2);
    println("deg2 : " +deg2);
    noStroke();
  }
  void delete() {
    size_ = 0.0;
  }
}


class bomb extends myShape {
  bomb() {
    float r = random(50, 350);
    float d;
    if (100 < r && r<= 200) {
      d = random(100, 200);
    } else {
      d = random(200, 300);
    }
    a_ = random(0, 360);
    size_ = 30;
    x_ = width/2 + d*cos(a_);
    y_ = height/2 + d*sin(a_);
  }
  void display() {   
    color inside;
    inside = #D81616;
    fill(inside);
    ellipse(x_, y_, size_, size_);

    stroke(#D81616);
    line(x_, y_-0.5*size_, x_, y_-size_);
    noStroke();
  }
  void equal(myShape p) {
    p.x_ = x_;
    p.y_ = y_;
    p.size_ = size_;
    p.a_ = a_;
  }
}


void mousePressed() {

  if (intro) {
    intro=false;
    normal = true;
    startTime = millis();
    player.rewind();
    player.play();
  }
  if (stop) {
    on = true;
    stop = false; 
    normal = true;
    startTime = millis();
    currentSeconds = totalSeconds;
    lastMillis = 0;

    score = 0;
    if (player.isPlaying()) {
      player.pause();
      player.rewind();
      player.play();
    } else {
      player.play();
    }
    setup();
  }
}


void jump() {
  micVolumeTarget=int(map(volumeAnalyzer.analyze(), 0, 1, 0, 40));
  if (micVolumeTarget > 2) {
    if (cochetLong - cochetShort == 0) {
      a = !a;
    }
  }
}